import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

import "Thurallor.Common.Turbine"; -- These files are not needed if you have the Turbine Utilities library installed.
import "Thurallor.Common.Utils.Utils_1"; -- In this file, only the DoCallbacks() function is used.
import "Thurallor.Common.UI.ProgressBar";

Turbine.Shell.WriteLine("ProgressBar Demo v" .. plugin:GetVersion());

window = Turbine.UI.Lotro.Window();
window:SetText("ProgressBar Demo");
window:SetSize(400, 140);
window:SetVisible(true);

label1 = Turbine.UI.Label();
label1:SetParent(window);
label1:SetPosition(50, 30);
label1:SetSize(300, 30);
label1:SetFont(Turbine.UI.Lotro.Font.Verdana16);
label1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

label2 = Turbine.UI.Label();
label2:SetParent(window);
label2:SetPosition(50, 50);
label2:SetSize(300, 30);
label2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
label2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

label3 = Turbine.UI.Label();
label3:SetParent(window);
label3:SetPosition(50, 93);
label3:SetSize(300, 30);
label3:SetFont(Turbine.UI.Lotro.Font.Verdana16);
label3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

-- This "work function" does nothing except display an incrementing number.
i = 0;
total_iterations = 5000000;
function workFunc(workToDo)
    label2:SetText("workToDo = " .. workToDo);
    for n = 1, workToDo do
        -- Do something useful here.
        i = i + 1;
        label1:SetText("workFunc iterations: " .. i);
    end
    return i / total_iterations; -- a "progress" indicator between 0 and 1
end

-- 10 FPS is probably the minimum to still be able to get your other business done while this is running in the client.
-- Note: The FPS counter in the client (Ctrl+F) displays the actual frame rate + 2.
targetFrameRate = 10;
Turbine.Shell.WriteLine("Target frame rate: " .. targetFrameRate .. " FPS");

-- Create the ProgressBar control and add it to the window.
bar = Thurallor.UI.ProgressBar(workFunc, targetFrameRate);
bar:SetParent(window);
bar:SetPosition(25, 83);
bar:SetSize(350, 9);

-- Add a callback so we can be notified when the progress bar changes:
bar.ProgressChanged = function(_, progress)
    label3:SetText("progress: " .. math.floor(progress * 100) .. "%");
    if (progress >= 1) then
        window:Close();
        Turbine.Shell.WriteLine("Demo complete.");
    end
end